/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  TransactionMessageCollateralDto,
  TransactionMessageCollateralDtoFromJSON,
  TransactionMessageCollateralDtoFromJSONTyped,
  TransactionMessageCollateralDtoToJSON,
} from './TransactionMessageCollateralDto';

/**
 *
 * @export
 * @interface TransferResponse
 */
export interface TransferResponse {
  /**
   *
   * @type {string}
   * @memberof TransferResponse
   */
  senderBic: string;
  /**
   *
   * @type {string}
   * @memberof TransferResponse
   */
  recipientBic: string;
  /**
   * Transaction amount
   * @type {number}
   * @memberof TransferResponse
   */
  amount: number;
  /**
   * Transaction currency
   * @type {string}
   * @memberof TransferResponse
   */
  currency: string;
  /**
   *
   * @type {string}
   * @memberof TransferResponse
   */
  endToEndId: string;
  /**
   *
   * @type {Date}
   * @memberof TransferResponse
   */
  requestDate?: Date;
  /**
   *
   * @type {Date}
   * @memberof TransferResponse
   */
  validUntil: Date;
  /**
   *
   * @type {boolean}
   * @memberof TransferResponse
   */
  reject: boolean;
  /**
   *
   * @type {string}
   * @memberof TransferResponse
   */
  referenceInfo?: string;
  /**
   *
   * @type {TransactionMessageCollateralDto}
   * @memberof TransferResponse
   */
  collateral?: TransactionMessageCollateralDto;
}

export function TransferResponseFromJSON(json: any): TransferResponse {
  return TransferResponseFromJSONTyped(json, false);
}

export function TransferResponseFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransferResponse {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    senderBic: json['senderBic'],
    recipientBic: json['recipientBic'],
    amount: json['amount'],
    currency: json['currency'],
    endToEndId: json['endToEndId'],
    requestDate: !exists(json, 'requestDate')
      ? undefined
      : new Date(json['requestDate']),
    validUntil: new Date(json['validUntil']),
    reject: json['reject'],
    referenceInfo: !exists(json, 'referenceInfo')
      ? undefined
      : json['referenceInfo'],
    collateral: !exists(json, 'collateral')
      ? undefined
      : TransactionMessageCollateralDtoFromJSON(json['collateral']),
  };
}

export function TransferResponseToJSON(value?: TransferResponse | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    senderBic: value.senderBic,
    recipientBic: value.recipientBic,
    amount: value.amount,
    currency: value.currency,
    endToEndId: value.endToEndId,
    requestDate:
      value.requestDate === undefined
        ? undefined
        : value.requestDate.toISOString(),
    validUntil: value.validUntil.toISOString(),
    reject: value.reject,
    referenceInfo: value.referenceInfo,
    collateral: TransactionMessageCollateralDtoToJSON(value.collateral),
  };
}
